#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 1.0
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 White

extern int Minutes = 0;
extern int MACD_Fast = 12;
extern int MACD_Slow = 26;
extern int MACD_MA = 9;
extern int BarsToCount = 1000;
extern string TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";
double g_ibuf_104[];
double g_ibuf_108[];
double g_ibuf_112[];
string gs_164;
double g_imacd_196;
double g_imacd_204;

int init() {
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 5, Red);
   SetIndexBuffer(0, g_ibuf_104);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 5, Blue);
   SetIndexBuffer(1, g_ibuf_108);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, 5, White);
   SetIndexBuffer(2, g_ibuf_112);
   if (Minutes < Period()) Minutes = Period();
   switch (Minutes) {
   case 1:
      gs_164 = "Period_M1";
      break;
   case 5:
      gs_164 = "Period_M5";
      break;
   case 15:
      gs_164 = "Period_M15";
      break;
   case 30:
      gs_164 = "Period_M30";
      break;
   case 60:
      gs_164 = "Period_H1";
      break;
   case 240:
      gs_164 = "Period_H4";
      break;
   case 1440:
      gs_164 = "Period_D1";
      break;
   case 10080:
      gs_164 = "Period_W1";
      break;
   case 43200:
      gs_164 = "Period_MN1";
      break;
   default:
      gs_164 = "Current Timeframe";
   }
   IndicatorShortName("FlatTrend w MACD [" + gs_164 + "](" + MACD_Fast + "," + MACD_Slow + "," + MACD_MA + ")");
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int lia_0[];
   int l_shift_12 = 0;
   int l_ind_counted_16 = IndicatorCounted();
   ArrayCopySeries(lia_0, 5, Symbol(), Minutes);
   int li_8 = Bars - l_ind_counted_16;
   li_8 = MathMax(li_8, Minutes / Period());
   li_8 = MathMin(li_8, BarsToCount);
   l_shift_12 = 0;
   for (int l_index_4 = 0; l_index_4 < li_8; l_index_4++) {
      if (Time[l_index_4] < lia_0[l_shift_12]) l_shift_12++;
      g_ibuf_104[l_index_4] = 0;
      g_ibuf_108[l_index_4] = 0;
      g_ibuf_112[l_index_4] = 0;
      g_imacd_196 = iMACD(NULL, Minutes, MACD_Fast, MACD_Slow, MACD_MA, PRICE_CLOSE, MODE_SIGNAL, l_shift_12);
      g_imacd_204 = iMACD(NULL, Minutes, MACD_Fast, MACD_Slow, MACD_MA, PRICE_CLOSE, MODE_MAIN, l_shift_12);
      if (g_imacd_196 < g_imacd_204 && g_imacd_204 > 0.0) g_ibuf_108[l_index_4] = 1;
      if (g_imacd_196 > g_imacd_204 && g_imacd_204 < 0.0) g_ibuf_104[l_index_4] = 1;
      if (g_ibuf_104[l_index_4] == 0.0 && g_ibuf_108[l_index_4] == 0.0) g_ibuf_112[l_index_4] = 1;
   }
   return (0);
}